//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main()
{
  vector<int> coll1;
  list<int> coll2;

  INSERT_ELEMENTS(coll1,1,9);
  PRINT_ELEMENTS(coll1,"1- :\n");

  //   coll1  coll2
  //  -    ,
  //         
  copy (coll1.begin(), coll1.end(),         // 
        back_inserter(coll2));              // 

  //   coll2
  //  -    cout
  //        
  cout << ToRus("2- :\n");
  copy (coll2.begin(), coll2.end(),         // 
        ostream_iterator<int>(cout," "));   // 
  cout << endl;

  //   coll1  coll2   
  //  -     
  copy (coll1.rbegin(), coll1.rend(),       // 
        coll2.begin());                     // 
  PRINT_ELEMENTS(coll1,"1-   :\n");

  //    coll2
  cout << ToRus("  2- :\n");
  copy (coll2.begin(), coll2.end(),         // 
        ostream_iterator<int>(cout," "));   // 
  cout << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------